'UP-Einheit 24V fr Berker, Gira und Jung Bewegungsmelder
'erster Ausgang wird bei Dunkelheit und Bewegung gesetzt, wie normaler Reilaisausgang
'zweiter Ausgang bleibt wrend der Bewegung gesetzt mit 6s Ausschaltverzgerung
'
'V0.00   24.02.2013  Programm begonnen und getestet
'V0.10   01.06.2013  Watchdog eingefgt
'V0.11   25.08.2013  Takt auf genau 50Hz gendert
'
'##############################################################################
'Licence
'##############################################################################
'Copyright (C) 2014  Christian Kreuzer (ch-kr@utanet.at)
'This program is free software; you can redistribute it and/or modify it
'under the terms of the GNU General Public License as published by the
'Free Software Foundation; either version 2 of the Licence.
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
'See the GNU General Public License for more details.
'You should have received a copy of the GNU General Public License along with
'this program; if not, write to the Free Software Foundation,
'Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

$regfile = "attiny13a.dat"
$crystal = 128000
$hwstack = 8
$swstack = 16
$framesize = 16
$prog , &H77 , &HFB ,                                       'Fuses: LOW: 0x77; HIGH: 0xFB
'$sim

Ddrb = &B00000111
Portb = &B00000000

Const Schaltschwelle = 500                                  'Einschaltschwelle fr ADC Wert

Dim W_temp As Word
Dim B_adc3_on As Byte                                       'Zhler fr Impulslnge auf ADC3
Dim B_adc4_on As Byte                                       'Zhler fr Impulslnge auf ADC4
Dim W_bewegung As Word                                      'Zhler fr Abschalten des Signals Bewegung

P_licht Alias Portb.0                                       'Ausgang fr Licht
P_bewegung Alias Portb.1                                    'Ausgang Bewegung
P_takt Alias Portb.2                                        'Ausgang Takt fr BWM
'Alias Pinb.3                                               'ADC3 Aus
'Alias Pinb.4                                               'ADC2 Ein, Bewegung

'ADC
Config Adc = Single , Prescaler = 2 , Reference = Avcc

'Timer
Const Timer0_reload = 115
Config Timer0 = Timer , Prescale = 8                        ' Irq alle 10ms
On Timer0 Timer0_irq , Nosave
Enable Timer0

'Watchdog
Config Watchdog = 1024
Start Watchdog

Enable Interrupts

'##############################################################################
'Hauptprogramm
'##############################################################################
Do
   'Prfe auf Impuls von ADC2 (Ein, Bewegung)
   W_temp = Getadc(2)
   If W_temp > Schaltschwelle Then
      Incr B_adc3_on
   Else
      If B_adc3_on > 1 And B_adc3_on < 4 Then               'kurzer Impuls -> Bewegung
         W_bewegung = 600                                   '6 Sekunden
      End If
      If B_adc3_on > 4 Then                                 'langer Impuls -> Licht ein
         Set P_licht
      End If
      B_adc3_on = 0
   End If

   'Prfe auf Impuls von ADC3 (Aus)
   W_temp = Getadc(3)
   If W_temp > Schaltschwelle Then
      Incr B_adc4_on
   Else
      If B_adc4_on > 4 Then                                 'langer Impuls -> Licht aus
         Reset P_licht
      End If
      B_adc4_on = 0
   End If

   'Signal Bewegung
   If W_bewegung > 0 Then
      Set P_bewegung
      Decr W_bewegung
   Else
      Reset P_bewegung
   End If

   'Takt fr BWM
   Toggle P_takt

   Reset Watchdog
   Power Idle
Loop


'##############################################################################
'Interrupts
'##############################################################################
Timer0_irq:
   push R23
   Timer0 = Timer0_reload
   pop r23
Return